#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum MetricColumnAggregation {
    #[serde(rename = "TOTAL_COUNT")]
    TotalCount,
    #[serde(rename = "TOTAL_DURATION")]
    TotalDuration,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl MetricColumnAggregation {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            MetricColumnAggregation::TotalCount => "TOTAL_COUNT",
            MetricColumnAggregation::TotalDuration => "TOTAL_DURATION",
            MetricColumnAggregation::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for MetricColumnAggregation {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for MetricColumnAggregation {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for MetricColumnAggregation {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<MetricColumnAggregation, conjure_object::plain::ParseEnumError> {
        match v {
            "TOTAL_COUNT" => Ok(MetricColumnAggregation::TotalCount),
            "TOTAL_DURATION" => Ok(MetricColumnAggregation::TotalDuration),
            v => v.parse().map(|v| MetricColumnAggregation::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for MetricColumnAggregation {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<MetricColumnAggregation, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the MetricColumnAggregation enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
